/* -------------------------------------------------------------------------- */
/*                                  Libraries                                 */
/* -------------------------------------------------------------------------- */
import React from "react";
import { Switch } from "@headlessui/react";
/* -------------------------------------------------------------------------- */
/*                                    Hooks                                   */
/* -------------------------------------------------------------------------- */
import { useUIViewModel } from "ui/controller/uiViewModel";
import { useUIStore } from "ui/data/uiSlice";
/* -------------------------------------------------------------------------- */
/*                                    Icons                                   */
/* -------------------------------------------------------------------------- */
import { ReactComponent as SVGArrowIcon } from "assets/svg/arrow-right.svg";
import classNames from "classnames";
/* -------------------------------------------------------------------------- */
/*                      Side navigation drawer controller                     */
/* -------------------------------------------------------------------------- */
export default function DrawerController() {
  const store = useUIStore();

  const { isDrawerCollapsed: enabled, toggleDrawer } = useUIViewModel(store);

  return (
    <Switch checked={enabled} onChange={toggleDrawer}>
      <span
        aria-hidden="true"
        className=" transition-colors inline-block h-12 w-12 p-3 rounded-full bg-main hover:bg-serv-500 ring-0"
      >
        <SVGArrowIcon className={classNames("w-full h-full stroke-white transform transition duration-300 ease-in-out", {"rotate-180": !enabled})} />
      </span>
    </Switch>
  );
}
